import { ClassTransformOptions } from 'class-transformer';
import { BrokerEvent } from '../interfaces/broker-event.interface';
import { ClassType } from '../types/class.type';
import DoveClient from './dove.client';
import { BrokerEventSubscriber } from './event-subscriber/broker-event-subscriber';
export default class TransformableDoveClient extends DoveClient {
    private classTransformOptions?;
    setClassTransformOptions(classTransformOptions: ClassTransformOptions): void;
    invoke<T>(pattern: string, data: unknown, target?: ClassType<T>): Promise<T>;
    subscribe<T>(pattern: string, listener: (data: T, brokerEvent?: BrokerEvent) => void, target?: ClassType<T>): BrokerEventSubscriber;
}
