"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const class_transformer_1 = require("class-transformer");
const inversify_1 = require("inversify");
const dove_client_1 = __importDefault(require("./dove.client"));
let TransformableDoveClient = class TransformableDoveClient extends dove_client_1.default {
    setClassTransformOptions(classTransformOptions) {
        this.classTransformOptions = classTransformOptions;
    }
    invoke(pattern, data, target) {
        const _super = Object.create(null, {
            invoke: { get: () => super.invoke }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield _super.invoke.call(this, pattern, data);
            return class_transformer_1.plainToClass(target, response, this.classTransformOptions);
        });
    }
    subscribe(pattern, listener, target) {
        return super.subscribe(pattern, (data, brokerEvent) => {
            return listener(class_transformer_1.plainToClass(target, data, this.classTransformOptions), brokerEvent);
        });
    }
};
TransformableDoveClient = __decorate([
    inversify_1.injectable()
], TransformableDoveClient);
exports.default = TransformableDoveClient;
