"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const iso_date_transformer_1 = require("../../helpers/iso-date-transformer");
const is_broker_event_typeguard_1 = require("../../type-guards/is-broker-event.typeguard");
/**
 * Built-in middleware that transforms ISO strings to Date object,
 * in outcoming and incoming messages.
 *
 * (Works both in broker and client modes)
 */
class IsoDateTransformerMiddleware {
    onRequest(context) {
        context.brokerEvent.data = iso_date_transformer_1.IsoDateTransformer.transform(context.brokerEvent.data);
    }
    onResponse(message) {
        if (is_broker_event_typeguard_1.isBrokerEvent(message)) {
            return Object.assign(Object.assign({}, message), { data: iso_date_transformer_1.IsoDateTransformer.transform(message.data) });
        }
        return iso_date_transformer_1.IsoDateTransformer.transform(message);
    }
}
exports.default = IsoDateTransformerMiddleware;
